/**
*	http.c
*	lbg[NԊOR	BASE64GR[h^fR[h
*	BasicF:RFC2617
*	Copyright Junnichi Tomaru
*/
#include	"remoir.h"

const char	base64_str[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/**
*	24rbg̃f[^6rbg4ɃGR[h
*	 in	  data: ϊf[^
*		srclen: 
*		  dest: GR[hi[
*	out	̊i[
*/
byte	*encode_char( dword data, int srclen, byte *dest )
{
	int	i, j, x;
	char	idx, base;
	byte	*p;

	for( i = srclen; i < 2; i++ ){	/* ŏIʒǔvZ */
		data <<= 8;
	}
	p = dest;
	j = srclen + 2;
	for( base = 18, x = 0; x < j; x++, p++, base -= 6 ){	/* BASE64ϊ */
		idx = ( data >> base ) & 0x3f;
		*p = base64_str[idx];
	}
	for( i = x; i < 4; i++, p++ ){/* [̔f */
		*p = '=';	/* [ */
	}

	return	p;
}


/**
*	GR[h
*	 in	 src: ̕
*		dest: GR[hꂽ
*	out	Ȃ
*/
void	base64_encode( byte *src, byte *dest )
{
	byte	*p, *q;
	dword	dw;
	int	i, j;

	p = src;
	q = dest;
	dw = 0;
	for( i = 0; *p != '\0'; p++ ){
		dw <<= 8;
		dw |= *p;
		if( i == 2 ){	/* 24bitPʂŕҏW */
			q = encode_char( dw, i, q );
			i = 0;
			dw = 0;
		}
		else{
			i++;
		}
	}
	if( i ){	/* 24bitɖȂꍇ */
		q = encode_char( dw, i - 1, q );
	}
	*q = '\0';
}


/**
*	Base64𐔒lɕϊ
*	 in	
*	out	-1:Ȃ
*/
int	searchchar( char c )
{
	int	i;

	for( i = 0; i < 64; i++ ){
		if( base64_str[i] == c ){
			break;
		}
	}
	if( i == 64 ){
		return	( -1 );
	}
	else{
		return	i;
	}
}


/**
*	S(QSrbg)fR[h
*	 in	 src: GR[hꂽ
*		dest: fR[h
*	out	̊i[|C^
*/
byte	*decode_str( byte *src, byte *dest )
{
	byte	*p;
	ul_t	t;

	p = src;
	t.data = searchchar( *p );	/* P */
	p++;
	t.data <<= 6;
	t.data |= searchchar( *p );	/* Q */
	p++;
	t.data <<= 6;
	t.data |= searchchar( *p );	/* R */
	p++;
	t.data <<= 6;
	t.data |= searchchar( *p );	/* S */
	*dest = t.bytes.hl;
	dest++;
	*dest = t.bytes.lh;
	dest++;
	*dest = t.bytes.ll;
	dest++;

	return	dest;
}


/**
*	BASE64fR[h
*	 in	 src: GR[hꂽ
*		dest: fR[h
*	out	0: 1:񂪖 2:񒷂Ⴄ
*/
int	base64_decode( byte *src, byte *dest )
{
	byte	i, len, *p, *q;

	if( src == NULL ){	/* NULL pointer */
		return	( -1 );
	}
	len = strlen( (char *)src );
	if( len % 4 ){		/* 4̔{̒ł͂Ȃ */
		return	( -2 );
	}
	p = src;
	q = dest;
	for( i = 0; i < len; i += 4 ){	/* 4fR[h */
		q = decode_str( p, q );
		p += 4;
	}
	*q = '\0';
	return	0;
}


/* end of base64.c */
