/**
*	[gԊOR	`
*	Copyright Junnichi Tomaru
*/

/* ----- RAM ----- */
#define	RAMTOP		0xf780
#define	RAMUSRTOP	0xfb80
#define	RAMBOTTOM	0xff7f

/* ----- DI,EI ----- */
#define	DI		(byte)1
#define	EI		(byte)0

/**
*	Mp[Nobt@(RAMg) 
*	Mp: F780 - FB7F(1kB)
*	Mp: FB80 - FF7F(1kB)
*/
#define	TXBUFSIZE	1024U
#define	RXBUFSIZE	1024U
#define	TXBUF		RAMTOP
#define	RXBUF		( RAMTOP + TXBUFSIZE )
#define	DHCP_TXBUF	RAMTOP
#define	DHCP_RXBUF	( RAMTOP + TXBUFSIZE )

/* ----- EEPROMAhX` ----- */
#define	EEP_MAC		0x0000
#define	EEP_IRFLG	0x0008
#define	EEP_HTTP	0x0009
#define	EEP_ADDR	0x000a
#define	EEP_MASK	0x000c
#define	EEP_GW		0x000e
#define	EEP_HOST	0x0010
#define	EEP_PW		0x0018
#define	EEP_PORT1	0x0020
#define	EEP_PORT2	0x0028
#define	EEP_PORT3	0x0030
#define	EEP_PORT4	0x0038
#define	EEP_CTRL1	0x0040
#define	EEP_CTRL2	0x0048
#define	EEP_CTRL3	0x0050
#define	EEP_CTRL4	0x0058
#define	EEP_CTRL5	0x0060
#define	EEP_CTRL6	0x0068
#define	EEP_CTRL7	0x0070
#define	EEP_DATA1	0x0080
#define	EEP_DATA2	0x0100
#define	EEP_DATA3	0x0180
#define	EEP_DATA4	0x0200
#define	EEP_DATA5	0x0280
#define	EEP_DATA6	0x0300
#define	EEP_DATA7	0x0380

/* ----- lbg[N֌W ----- */
#define	PHYSICALADDR_SIZE	6
#define	IP_BROADCAST	0xffffffff
#define	INADDR_NONE	0xffffffff
#define	IPADDR		0xc0a80067	/* 192.168.0.103 */
#define	NETMASK		0xffffff00	/* 255.255.255.0 */
#define	GATEWAY		0xc0a80001	/* 192.168.0.1 */

/* ----- DHCP\ ----- */
#define	CNT_EXPIRE	0
#define	CNT_REBIND	1
#define	CNT_RENEW	2
#define	CNT_REM		3

/* ----- DHCPtO ----- */
#define	DHCP_EXPIRE	4
#define	DHCP_REBIND	2
#define	DHCP_RENEW	1
#define	DHCP_CLEAR	0

/* ----- LED ----- */
#define	LISTEN_ON()	IO.PDR2.BIT.B4=1
#define	LISTEN_OFF()	IO.PDR2.BIT.B4=0
#define	ESTABLISH_ON()	IO.PDR2.BIT.B3=1
#define	ESTABLISH_OFF()	IO.PDR2.BIT.B3=0
#define	COMPLETE_ON()	IO.PDR1.BIT.B2=1
#define	COMPLETE_OFF()	IO.PDR1.BIT.B2=0
#define	LEARN_ON()	IO.PDR2.BIT.B0=1
#define	LEARN_OFF()	IO.PDR2.BIT.B0=0

/* ----- ԊO ----- */
#define	IR_OUT		IO.PDR1.BIT.B1
#define	OUT1_ENBL()	IO.PDR3.BIT.B4=1
#define	OUT2_ENBL()	IO.PDR3.BIT.B5=1
#define	OUT3_ENBL()	IO.PDR3.BIT.B6=1
#define	OUT4_ENBL()	IO.PDR3.BIT.B7=1
#define	OUT1_DSBL()	IO.PDR3.BIT.B4=0
#define	OUT2_DSBL()	IO.PDR3.BIT.B5=0
#define	OUT3_DSBL()	IO.PDR3.BIT.B6=0
#define	OUT4_DSBL()	IO.PDR3.BIT.B7=0
#define	IR_IN		IO.PDR1.BIT.B0
#define	IRRCV_ENBL()	IO.PDR7.BIT.B2=0
#define	IRRCV_DSBL()	IO.PDR7.BIT.B2=1
#define	IR_TRAILER	120	/* 6ms(50us * 120) */

/* ----- ̓|[g ----- */
#define	INPORT1		!IO.PDRB.BIT.B0
#define	INPORT2		!IO.PDRB.BIT.B1
#define	INPORT3		!IO.PDRB.BIT.B2
#define	INPORT4		!IO.PDRB.BIT.B3
#define	INPORT5		!IO.PDRB.BIT.B4
#define	INPORT6		!IO.PDRB.BIT.B5
#define	INPORT7		!IO.PDRB.BIT.B6
#define	INPORT8		!IO.PDRB.BIT.B7

/* ----- fBbvXCb` ----- */
#define	DIPSW		(~IO.PDR5.BYTE)
#define	ADDRFIX		IO.PDR5.BIT.B3
#define	LEARN		IO.PDR5.BIT.B7

/* end of define.h */
