/**
*	dhcp.h
*	DHCPwb_
*	Copyright (c)Junnichi Tomaru
*/
#define	BOOTPS_PORT	67U
#define	BOOTPC_PORT	68U

#define	DHCPMSG_SIZE		300U
#define	BOOTPMAIN_SIZE		236U	/* IvVȊO̒ */

#define	BOOTP_MAGICCODE		0x63825363	/* }WbNR[h */
#define	BOOTP_BOOTREQ		1		/* u[gv */
#define	BOOTP_BOOTREPLY		2		/* u[g */
#define	BOOTP_HWADDR		1		/* n[hAhX(C[Tlbg͂P) */
#define	BOOTP_HWSIZE		6		/* n[hAhX(C[Tlbg͂U) */
/* pPbgR[h(Mp) */
#define	BOOTP_DISCOVER		0x350101	/* pPbg */
#define	BOOTP_OFFER		0x350102	/* 񋟃pPbg */
#define	BOOTP_REQUEST		0x350103	/* vpPbg */
#define	BOOTP_DECLINE		0x350104	/* ۃpPbg */
#define	BOOTP_PACK		0x350105	/* mFpPbg */
#define	BOOTP_PNAK		0x350106	/* ے艞pPbg */
#define	BOOTP_RELEASE		0x350107
#define	BOOTP_INFORM		0x350108

/* bZ[W^Cv(Hłg) */
#define	DHCP_DISCOVER		1	/* pPbg */
#define	DHCP_OFFER		2	/* 񋟃pPbg */
#define	DHCP_REQUEST		3	/* vpPbg */
#define	DHCP_DECLINE		4	/* ۃpPbg */
#define	DHCP_PACK		5	/* mFpPbg */
#define	DHCP_PNAK		6	/* ے艞pPbg */
#define	DHCP_RELEASE		7	
#define	DHCP_INFORM		8	

#define	DHCP_ABORT		0	/* DHCP */
#define	DHCP_INIT		10
#define	DHCP_BOUND		11	/*  */
#define	DHCP_RENEWING		12
#define	DHCP_REBINDING		13

/* IvV */
#define	DHCP_UNKNOWN_MESSAGE	0

#define	DHCP_SUBNETMASK		1	/* lbg[ÑTulbg}XN */
#define	DHCP_SUBNETMASKLEN	4	

#define	DHCP_ROUTER		3	/* [^IPAhX */
#define	DHCP_ROUTERLEN		4

#define	DHCP_HOSTNAME		12

#define	DHCP_REQIPADDR		50
#define	DHCP_REQIPADDRLEN	4

#define	DHCP_LEASETIME		51	/* IPAhXݗ^ */
#define	DHCP_LEASETIMELEN	4

#define	DHCP_MESSAGETYPE	53	/* bZ[W^Cv */
#define	DHCP_MESSAGETYPELEN	1

#define	DHCP_SERVERID		54	/* DHCPT[oIPAhX */
#define	DHCP_SERVERIDLEN	4

#define	DHCP_PRMREQLIST		55	/* p[^NGXgXg */
#define	DHCP_PRMREQLISTLEN	3

#define	DHCP_RENEWALTIME	58	/* RENEWAL(T1) */
#define	DHCP_RENEWALTIMELEN	4

#define	DHCP_REBINDTIME		59	/* REBIND(T2) */
#define	DHCP_REBINDTIMELEN	4

#define	DHCP_CLIANTID		61	/* NCAgMACAhX */
#define	DHCP_CLIANTIDLEN	7

#define	BOOTP_MSGSTOPPER	0xff	/* XgbvR[h */

/* wb_ */
#define	DHCPMSG_TOP		0U
#define	DHCPMSG_OPCODE		(DHCPMSG_TOP+0)		/* Iy[VR[h */
#define	DHCPMSG_HWADDR		(DHCPMSG_TOP+1)		/* n[hAhX */
#define	DHCPMSG_HWLENGTH	(DHCPMSG_TOP+2)		/* n[hAhX */
#define	DHCPMSG_HCOUNT		(DHCPMSG_TOP+3)		/* zbvJEg */
#define	DHCPMSG_TRID		(DHCPMSG_TOP+4)		/* gUNVhc */
#define	DHCPMSG_SEC		(DHCPMSG_TOP+8)		/* b */
#define	DHCPMSG_RESERVED	(DHCPMSG_TOP+10)	/* gp */
#define	DHCPMSG_CLADDR		(DHCPMSG_TOP+12)	/* NCAghoAhX */
#define	DHCPMSG_USRADDR		(DHCPMSG_TOP+16)	/* [U[hoAhX */
#define	DHCPMSG_SVADDR		(DHCPMSG_TOP+20)	/* T[o[hoAhX */
#define	DHCPMSG_GWADDR		(DHCPMSG_TOP+24)	/* Q[gEFChoAhX */
#define	DHCPMSG_CLHWADDR	(DHCPMSG_TOP+28)	/* NCAgn[hAhX */
#define	DHCPMSG_SVNAME		(DHCPMSG_TOP+44)	/* T[o[zXg */
#define	DHCPMSG_BOOT		(DHCPMSG_TOP+108)	/* Nt@C */
#define	DHCPMSG_VENDOR		(DHCPMSG_TOP+236)	/* x_dl */
#define	DHCPMSG_SIZE		300U

/* end of dhcp.h */
