/**
*	I/O|[gł93C86C^[tF[X
*	Copyright (c)2009 Junnichi Tomaru
*/
#include	<machine.h>
#include	"iodefine.h"
#include	"userdef.h"

#define	EEP_CS	IO.PDR1.BIT.B7
#define	EEP_SK	IO.PDR1.BIT.B6
#define	EEP_DI	IO.PDR1.BIT.B5
#define	EEP_DO	IO.PDR1.BIT.B4


/**
*	`bvZNgグ
*	 in	Ȃ
*	out	Ȃ
*/
void	eepcs( void )
{
	EEP_SK = 1;	/* CS O SK グĂ */
	EEP_CS = 1;	/* CS */
}


/**
*	12rbgo(R}ho)
*	 in	f[^
*	out	Ȃ
*/
void	eepwrite12( word dat )
{
	byte	i;

	EEP_DI = 1;	/* X^[grbg */
	EEP_SK = 0;	/* SK  */
	dat <<= 4;	/* ŏʂɈړ */
	EEP_SK = 1;	/* SK グ */
	for( i = 0; i < 12; i++ ){
		/* f[^ŏʃrbgDIɃZbg */
		EEP_DI = ( dat & 0x8000 )? 1: 0;
		dat <<= 1;
		EEP_SK = 0;	/* SK  */
		nop( );		/* 62.5 * 4 = 250ns */
		nop( );
		nop( );
		nop( );
		EEP_SK = 1;	/* SK オ胉b` */
	}
}


/**
*	16rbg
*	 in	Ȃ
*	out	16rbgf[^
*/
word	eepread16( void )
{
	byte	i;
	word	ret;

	ret = 0;
	for( i = 0; i < 16; i++ ){
		EEP_SK = 0;	/* SK  */
		nop( );		/* 62.5 * 4 = 250ns */
		nop( );
		nop( );
		nop( );
		EEP_SK = 1;	/* SK オm */
		ret <<= 1;	/* Vtgwith fBC(250ns) */
		nop( );
		nop( );
		nop( );
		if( EEP_DO == 1 ){	/* rbgf[^ɓ */
			ret |= 0x1;
		}
	}

	return	ret;
}


/**
*	PUrbgo
*	 in	PUrbgf[^
*	out	Ȃ
*/
void	eepwrite16( int dat )
{
	byte	i;

	for( i = 0; i < 16; i++ ){
		/* f[^ŏʃrbgrbgPɃZbg */
		EEP_DI = ( dat & 0x8000 )? 1: 0;
		dat = dat << 1;
		EEP_SK = 0;	/* SK  */
		nop( );		/* 62.5 * 4 = 250ns */
		nop( );
		nop( );
		nop( );
		EEP_SK = 1;	/* SK オ胉b` */
	}
}


/**
*	xt@C
*	 in	Ȃ
*	out	Ȃ
*/
void	eepverify( void )
{
	EEP_CS = 0;	/* CS = Low */
	EEP_DI = 0;	/* DI = Low */
	EEP_CS = 1;	/* CS = High */
	while( EEP_DO == 0 )	/* DO  High ɂȂ̂҂ */
	;
}


/**
*	II
*	 in	Ȃ
*	out	Ȃ
*/
void	eepucs( void )
{
	EEP_CS = 0;		/* ׂĉ */
}


/**
*	wAhXPUrbgf[^ǂݏo
*	AhX(ʂUrbgL 0H-3FFH)
*	 in	ǂݍ݃AhX
*	out	PUrbgf[^
*/
word	geteeprom( int addr )
{
	word	ret;

	eepcs( );		/* `bvZNg */
	addr &= 0x3ff;		/* AhX10rbgL */
	addr |= 0x800;		/* ǂݏoR}h */
	eepwrite12( addr );	/* R}ho */
	ret = eepread16( );
	eepucs( );		/* I */

	return	ret;
}


/**
*	wAhXɂPUrbgf[^
*	ނƂ͉ʂɂȂƃ_݂(擪珑悤)
*	 in	addr:AhX
*		data:PUrbgf[^
*	out	Ȃ
*/
void	seteeprom( int addr, word data )
{
	word	dat;

	dat = ( data << 8 ) & 0xff;	/* ʂƉʂւ */
	dat |= ( data >> 8 ) & 0xff;
	addr &= 0x3ff;		/* AhX10rbgL */
	addr |= 0x400;		/* ݃R}h */

	eepcs( );		/* `bvZNg */
	eepwrite12( 0x300 );	/* vOCl[u */
	eepucs( );		/* I */

	eepcs( );		/* `bvZNg */
	eepwrite12( addr );	/* R}ho */
	eepwrite16( data );	/* f[^o */
	eepverify( );		/* xt@C */
	eepucs( );		/* I */

	eepcs( );		/* `bvZNg */
	eepwrite12( 0 );	/* vOfBZ[u */
	eepucs( );		/* I */
}


/* end of eeprom.c */
